-----------------------------------------------------------------------------------------------
-- Client Lua Script for OhmnaHelper
-- Copyright (c) NCsoft. All rights reserved
-- Some code/ideas was taken from Maat's OhmnaKnockbackAssist addon
-- 
-------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- OhmnaHelper Module Definition
-----------------------------------------------------------------------------------------------
local OhmnaHelper = {} 
local version = 17
local sin = math.sin
local cos =  math.cos
local rad = math.rad


	local posname = {}
	posname[1] = "NE"
	posname[2] = "SE"
	posname[3] = "SW"
	posname[4] = "NW"
	posname[5] = "SE"
	posname[6] = "SW"
	posname[7] = "N"
	
	
	local colors = {}
	colors[1] ="ff00ff00"
	colors[2] ="ff00ff00"
	colors[3] ="ff00ff00"
	colors[4] ="ff00ff00"
	colors[5] ="ffffff80"
	colors[6] ="ffffff80"
	colors[7] ="ffffff80"
	
	local sprites = {}
	sprites[1] = "achievements:sprAchievements_Icon_Group"
	sprites[2] = "achievements:sprAchievements_Icon_Group"
	sprites[3] = "achievements:sprAchievements_Icon_Group"
	sprites[4] = "achievements:sprAchievements_Icon_Group"
	sprites[5] = "Crafting_RunecraftingSprites:sprRunecrafting_Omni"
	sprites[6] = "Crafting_RunecraftingSprites:sprRunecrafting_Omni"
	sprites[7] = "Crafting_RunecraftingSprites:sprRunecrafting_Omni"

local LocalesNames = {
	["Dreadphage Ohmna"] = {
		[1] = "Dreadphage Ohmna",
		[2] = "Schreckensphage Ohmna",
		[3] = "Ohmna la Terriphage",
		[99] = "Raid Target Dummy",  --For Testing
	},

	["Ravenous Maw of the Dreadphage"] = {
		[1] = "Ravenous Maw of the Dreadphage",
		[2] = "Unersättliches Maul der Schreckensphage", 
		[3] = "Gueule vorace de la Terriphage",
		[99] = "Formidable Target Dummy",
	},
	["Body Slam"] = { -- 72662
		[1] = "Body Slam",
		[2] = "Bodyslam",
		[3] = "Coup corporel",
		[99] = "Blade Dance",
	},
	["Devour"] = { -- 60925
		[1] = "Devour",
		[2] = "Verschlingen",
		[3] = "Dévorer",
		[99] = "Mind Over Body",
	},
	["Genetic Torrent"] = { -- 72663
		[1] = "Genetic Torrent",
		[2] = "Genetische Strömung",
		[3] = "Torrent génétique",
		[99] = "Telekinetic Strike", --For testing only
	},
	["Erupt"] = { 
		[1] = "Erupt",  
		[2] = "Ausbrechen",  -- Possible German Name
		[3] = "Jaillir", -- Possible French Name
		[99] = "Haunt", --For testing only
	},
}




----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function OhmnaHelper:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function OhmnaHelper:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- OhmnaHelper OnLoad
-----------------------------------------------------------------------------------------------
function OhmnaHelper:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("OhmnaHelper.xml")
	Apollo.LoadSprites("OHSprite.xml","OHSprite")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- OhmnaHelper OnDocLoaded
-----------------------------------------------------------------------------------------------
function OhmnaHelper:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.Overlay = Apollo.LoadForm(self.xmlDoc, "Overlay", "InWorldHudStratum", self)
	    self.PopUp = Apollo.LoadForm(self.xmlDoc, "OHPopUp", nil, self)
		if self.Overlay == nil then
		Print("Error")
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
	    self.PopUp:Show(false, true)
	    self.Overlay:Show(true)
		-- Adds
		self.NorthEastLoc = Vector3.New(2840.19,-450.15,-153.72)
		self.SouthEastLoc = Vector3.New(2832.31,-450.15,-75.42)
		self.NorthWestLoc = Vector3.New(2749.19,-450.15,-166.47)
		self.SouthWestLoc = Vector3.New(2746.31,-450.15,-79.13)
		
		-- 3 Heads
		self.HeadsNorthLoc = Vector3.New(2793.88,-448.15,-151.78)
		self.HeadsSouthEastLoc = Vector3.New(2822.44,-448.15,-101.72)
		self.HeadsSouthWestLoc = Vector3.New(2763.11,-448.15,-102.33)

		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)
--    	Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
    	Apollo.RegisterSlashCommand("ohelper", "OnOptions", self)
		Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)
		Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
		Apollo.RegisterEventHandler("InterfaceClick", "OnInterfaceClick", self)

		self.lineWidth = 4
		self.lineLength = 31
		
		self.checkBoxes = {}
		self.checkBoxes[1] = self.PopUp:FindChild("NEButton")
		self.checkBoxes[2] = self.PopUp:FindChild("SEButton")
		self.checkBoxes[3] = self.PopUp:FindChild("SWButton")
		self.checkBoxes[4] = self.PopUp:FindChild("NWButton")
		self.checkBoxes[5] = self.PopUp:FindChild("SEHButton")
		self.checkBoxes[6] = self.PopUp:FindChild("SWHButton")
		self.checkBoxes[7] = self.PopUp:FindChild("NHButton")
		self.checkBoxes[8] = self.PopUp:FindChild("KnockbackButton")
		self.OptionsButton = self.PopUp:FindChild("OptionsButton")
		self.OptionsPopUp = self.PopUp:FindChild("OptionsWindow")
		self.OptionsButton:AttachWindow(self.OptionsPopUp)
		
		self.watchList = {}
		
		self:FillOptionsWindow()
		self.Resolution = 5
		self.enableKnockback = self.Buttons[8] or false
		-- Locale Check
		local strCancel = Apollo.GetString(1)
		if strCancel == "Abbrechen" then
			self.Locale = 2
		elseif strCancel == "Annuler" then
			self.Locale = 3
		else
			self.Locale = 1
		end

		self.player = GameLib.GetPlayerUnit()
	end
end

function OhmnaHelper:OnInterfaceMenuListHasLoaded()
		Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "OhmnaHelper", {"InterfaceClick", "", ""})
end

function OhmnaHelper:OnInterfaceClick()
	self:OnOptions()
end



-----------------------------------------------------------------------------------------------
-- OhmnaHelperForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function OhmnaHelper:OnOK()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end

-- when the Cancel button is clicked
function OhmnaHelper:OnCancel()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end


function OhmnaHelper:OnOptions()
	if not self.PopUp:IsVisible() then
		self.PopUp:Invoke()
	else
		self:OnCancel()
	end

end
---------------------------------------------------------------------------------------------------
-- OHPopUp Functions
---------------------------------------------------------------------------------------------------

function OhmnaHelper:OnSettingChange( wndHandler, wndControl, eMouseButton )
	self.Buttons[1] = self.checkBoxes[1]:IsChecked()
	self.Buttons[2] = self.checkBoxes[2]:IsChecked()
	self.Buttons[3] = self.checkBoxes[3]:IsChecked()
	self.Buttons[4] = self.checkBoxes[4]:IsChecked()
	self.Buttons[5] = self.checkBoxes[5]:IsChecked()
	self.Buttons[6] = self.checkBoxes[6]:IsChecked()
	self.Buttons[7] = self.checkBoxes[7]:IsChecked()
	self.Buttons[8] = self.checkBoxes[8]:IsChecked()
	self.enableKnockback = self.Buttons[8]
	
	self.KSlider = self.PopUp:FindChild("KSliderBar"):GetValue()
	self.IconSize = self.PopUp:FindChild("IconSliderBar"):GetValue()
	
	self.PopUp:FindChild("SliderValue"):SetText(self.KSlider)
	self.PopUp:FindChild("SliderWindow"):Show(self.enableKnockback)
	self.PopUp:FindChild("IconSliderValue"):SetText(self.IconSize)
end


function OhmnaHelper:ClearMarks( wndHandler, wndControl, eMouseButton )
	self.checkBoxes[1]:SetCheck(false)
	self.checkBoxes[2]:SetCheck(false)
	self.checkBoxes[3]:SetCheck(false)
	self.checkBoxes[4]:SetCheck(false)
	self.checkBoxes[5]:SetCheck(false)
	self.checkBoxes[6]:SetCheck(false)
	self.checkBoxes[7]:SetCheck(false)
--	self.checkBoxes[8]:SetCheck(false)
	self:OnSettingChange()

end

function OhmnaHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
end

-----------------------------------------------------------------------------------------------
-- OhmnaHelper Instance
-----------------------------------------------------------------------------------------------
local OhmnaHelperInst = OhmnaHelper:new()
OhmnaHelperInst:Init()


function OhmnaHelper:OnNextFrame()
	self.player = GameLib.GetPlayerUnit()
	
	if self.player == nil then return end
	
	self.Overlay:DestroyAllPixies()
	
	if not self.player:IsInCombat() then
	  	Apollo.RemoveEventHandler("NextFrame",self)
		self.watchList = nil 
		self.watchList = {}
		return
	end

	self:DrawHelpers()
	
	if self.enableKnockback then
		for k, v in pairs(self.watchList) do
			self:SetupLines(v)
		end
	end
end


function OhmnaHelper:DrawHelpers()
    local pixieLocPoints = { 0, 0, 0, 0 }
	local pos = {}
	-- Adds
	pos[1] = GameLib.WorldLocToScreenPoint(self.NorthEastLoc)
    pos[2] = GameLib.WorldLocToScreenPoint(self.SouthEastLoc)
    pos[3] = GameLib.WorldLocToScreenPoint(self.SouthWestLoc)
    pos[4] = GameLib.WorldLocToScreenPoint(self.NorthWestLoc)

	-- Heads location
    pos[5] = GameLib.WorldLocToScreenPoint(self.HeadsSouthEastLoc)
    pos[6] = GameLib.WorldLocToScreenPoint(self.HeadsSouthWestLoc)
    pos[7] = GameLib.WorldLocToScreenPoint(self.HeadsNorthLoc)
	local size = self.IconSize or 30
	
 	for i = 1, 7 do
		if self.Buttons[i] then
			self.Overlay:AddPixie( {
			strText =posname[i], strSprite = sprites[i], cr = colors[i],
   			loc = {fPoints = pixieLocPoints, nOffsets = {pos[i].x-size,pos[i].y-size,pos[i].x+size,pos[i].y+size  } }
	       } )
		end
	end
end

--- Knockback assist starter
function OhmnaHelper:OnEnteredCombat(unit, bInCombat)
	--if GetCurrentZoneName() ~= "Genetic Archives - Act 2" then return end
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
	if uName == self:GetLocaleName("Ravenous Maw of the Dreadphage") or uName == self:GetLocaleName("Dreadphage Ohmna") then
		Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		self:CheckWatchList(unit)
--		self:CheckWatchList(self.player)
	end
end

--- Knockback assist starter
function OhmnaHelper:OnUnitCreated(unit)
	--if GetCurrentZoneName() ~= "Genetic Archives - Act 2" then return end
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
		if uName == self:GetLocaleName("Ravenous Maw of the Dreadphage") or uName == self:GetLocaleName("Dreadphage Ohmna") then
		self:CheckWatchList(unit)
	end
end

function OhmnaHelper:GetLocaleName(name)
--	self.Locale = 99 -- For Testing
	
--	Print(LocalesNames[name][self.Locale] .. "name")

	if LocalesNames[name] ~= nil then
		return LocalesNames[name][self.Locale]
	end
	return "Invalid Name"
end




function OhmnaHelper:CheckWatchList(unit)
	if not self.watchList[unit:GetId()] then
		self.watchList[unit:GetId()] = unit
	end
end


function OhmnaHelper:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	local tsave = {}
	tsave.Buttons = {}
	tsave.Buttons[1] = self.Buttons[1]
	tsave.Buttons[2] = self.Buttons[2]
	tsave.Buttons[3] = self.Buttons[3]
	tsave.Buttons[4] = self.Buttons[4]
	tsave.Buttons[5] = self.Buttons[5]
	tsave.Buttons[6] = self.Buttons[6]
	tsave.Buttons[7] = self.Buttons[7]
	tsave.Buttons[8] = self.Buttons[8]
	tsave.KSlider = self.KSlider
	tsave.IconSize = self.IconSize
	tsave.enableKnockback = self.enableKnockback
	return tsave
end


function OhmnaHelper:OnRestore(eLevel, saveData)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	for k,v in pairs(saveData) do
	   	self[k]=v
	end
end


function OhmnaHelper:FillOptionsWindow()
	if self.Buttons == nil then 
		self.Buttons = {}
		self.Buttons[1] = self.checkBoxes[1]:IsChecked()
		self.Buttons[2] = self.checkBoxes[2]:IsChecked()
		self.Buttons[3] = self.checkBoxes[3]:IsChecked()
		self.Buttons[4] = self.checkBoxes[4]:IsChecked()
		self.Buttons[5] = self.checkBoxes[5]:IsChecked()
		self.Buttons[6] = self.checkBoxes[6]:IsChecked()
		self.Buttons[7] = self.checkBoxes[7]:IsChecked()
		self.Buttons[8] = true
		self.KSlider = 10
		self.IconSize = 30
	end
	

	self.checkBoxes[1]:SetCheck(self.Buttons[1])
	self.checkBoxes[2]:SetCheck(self.Buttons[2])
	self.checkBoxes[3]:SetCheck(self.Buttons[3])
	self.checkBoxes[4]:SetCheck(self.Buttons[4])
	self.checkBoxes[5]:SetCheck(self.Buttons[5])
	self.checkBoxes[6]:SetCheck(self.Buttons[6])
	self.checkBoxes[7]:SetCheck(self.Buttons[7])
	self.checkBoxes[8]:SetCheck(self.Buttons[8])
	

	self.PopUp:FindChild("SliderWindow"):Show(self.enableKnockback or false)
	self.PopUp:FindChild("KSliderBar"):SetValue(self.KSlider or 10)
	self.PopUp:FindChild("SliderValue"):SetText(self.KSlider or 10)
	self.PopUp:FindChild("IconSliderBar"):SetValue(self.IconSize or 30)
	self.PopUp:FindChild("IconSliderValue"):SetText(self.IconSize or 30)
end


-- Line Plotting
function OhmnaHelper:SetupLines(targ)
	if targ:IsDead() or not targ:IsValid() then
	return
	end
	
	local alpha = "90"
	local tface = targ:GetFacing()
	local targ_screen_pos = GameLib.GetUnitScreenPosition(targ)

	local tangle = math.atan2(tface.x, tface.z)
	local leftV = tangle + rad(120)
	local rightV = tangle + rad(-120)

	local tpos = targ:GetPosition()
	local tposV = Vector3.New(tpos.x,tpos.y,tpos.z)

	local frontColor = "50ffff00"
	local sideColor = "500000ff"
	local sizeMod = 1
	
	-- the 2nd spell name is just for development
	if targ:IsCasting() then
		local spell = targ:GetCastName()
		if spell == self:GetLocaleName("Genetic Torrent") then
			frontColor ="90ff0000"
			sideColor ="90ff0000"
			sizeMod = 2
		elseif spell == self:GetLocaleName("Devour") then
			frontColor ="80ff8000"
			sideColor ="80ff8000"
			sizeMod = 2.5
		elseif spell == self:GetLocaleName("Body Slam") then
			frontColor ="90ff0000"
			sideColor ="500000ff"
			sizeMod = 2.5
		elseif spell == self:GetLocaleName("Erupt") then
			frontColor ="90ffff00"
			sideColor ="9000ff00"
			sizeMod = 2	
			if targ:GetName() == self:GetLocaleName("Ravenous Maw of the Dreadphage") then
--			if targ:GetName() == "Kurona Silversky" then
				self:ShowSafeSpots(targ)
			end
		end
	end
		
		
	local dist = self.lineLength
    local frontEnd = Vector3.New(tposV.x+dist*sin(tangle), tposV.y, tposV.z+dist*cos(tangle))
	local frontOffset = Vector3.InterpolateLinear(frontEnd, tposV, 0.90)

	self:DrawLine(frontEnd, frontOffset, frontColor,sizeMod)

	local leftEnd = Vector3.New(tposV.x+dist*sin(leftV), tposV.y, tposV.z+dist*cos(leftV))
	local leftOffset = Vector3.InterpolateLinear(leftEnd, tposV, 0.90)
	self:DrawLine(leftEnd, leftOffset, sideColor,sizeMod)

	local rightEnd = Vector3.New(tposV.x+dist*sin(rightV), tposV.y, tposV.z+dist*cos(rightV))
	local rightOffset = Vector3.InterpolateLinear(rightEnd, tposV, 0.90)
	self:DrawLine(rightEnd, rightOffset, sideColor,sizeMod)
end

--Line Drawing
function OhmnaHelper:DrawLine(startV, endV, col, sizeMod)
	local startPoint = GameLib.WorldLocToScreenPoint(startV)
	local endPoint = GameLib.WorldLocToScreenPoint(endV)
	local thick = self.KSlider or 10
	self.Overlay:AddPixie( { bLine = true, fWidth = thick*sizeMod, cr = col, loc = { fPoints = { 0, 0, 0, 0 }, nOffsets = { startPoint.x, startPoint.y, endPoint.x, endPoint.y } } })
end


function OhmnaHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
	 local OptionWindow = self.PopUp:FindChild("OptionsWindow")
	 OptionWindow:Show(not OptionWindow:IsShown())
end

function OhmnaHelper:ShowSafeSpots(v)
	local ValidPos = {}
	local count = 0
	local uName = v:GetName()
	local uPos = v:GetPosition()
	local uVec = Vector3.New(uPos.x,uPos.y,uPos.z)
	local uFace = v:GetFacing()
	local uAngle = math.atan2(uFace.x, uFace.z)
	ValidPos[count] = uPos
	count = count + 1
	self:PlotCircle(uVec, 31, "ffff0000", uAngle)
end


function OhmnaHelper:PlotCircle(originPositionVector, dist, color,uangle)
	local firstVector= Vector3.New(originPositionVector.x+dist*sin(uangle), originPositionVector.y, originPositionVector.z+dist*cos(uangle))
	local previousVector=firstVector
	local firstpoint = GameLib.WorldLocToScreenPoint(previousVector)
	local startPoint = firstpoint
	local pPoints = {0,0,0,0}
	local thickness = (self.KSlider or 10) / 2
	resolution = self.Resolution
	for i = 1, (resolution / 2)+1 do 
		local rotation_point = uangle + rad(-180 / (resolution /(i)))

		local currentVector = Vector3.New(originPositionVector.x+dist*sin(rotation_point), originPositionVector.y, originPositionVector.z+dist*cos(rotation_point))
		local endPoint = GameLib.WorldLocToScreenPoint(currentVector)

		self.Overlay:AddPixie( { bLine = true, fWidth = thickness,  cr = color, loc = { fPoints = pPoints, nOffsets = { startPoint.x, startPoint.y, endPoint.x, endPoint.y } }    } )

		previousVector=currentVector
		startPoint = endPoint
	end
	previousVector=firstVector
	startPoint = firstpoint
	
	for i = 1, (resolution / 2)+1 do 
		local rotation_point = uangle + rad(180 / (resolution /(i)))

		local currentVector = Vector3.New(originPositionVector.x+dist*sin(rotation_point), originPositionVector.y, originPositionVector.z+dist*cos(rotation_point))
		local endPoint = GameLib.WorldLocToScreenPoint(currentVector)

		self.Overlay:AddPixie( { bLine = true, fWidth = thickness,  cr = color, loc = { fPoints = pPoints, nOffsets = { startPoint.x, startPoint.y, endPoint.x, endPoint.y } }    } )

		previousVector=currentVector
		startPoint = endPoint
	end	
end


